# metadati
openapi: 3.0.3
info:
  title: My API - OpenAPI 3.0
  description: >
     Questo è un primo esempio di server, il
     suo repo lo trovate [qui](https://gitlab.com/users/divino.marchese/projects)
     buona fortuna!
  version: "0.1"
servers:
  - url: https://mioserver.edu
    description: una descrizione opzionale del server
# path  
paths:
  /users:
    get:
      summary: returns a list of users.
      description: optional extended description in CommonMark or HTML.
      responses:
        '200':    # status code
          description: A JSON array of user names (not optional)
          content:
            application/json: # media type
              schema: 
                type: array
                items: 
                  type: string
    post: 
      summary: create an user
      requestBody: 
        required: true
        content: 
          application/json: 
            schema: 
              type: object
              required:
                - id
                - name
                - surname
              properties:
                id: 
                  type: integer
                  format: int64
                name:
                  type: string
                surname:
                  type: string
      responses: 
        '201':
          description: object created
          content:
            application/json: 
              schema:
                type: string
  /users/{userId}:
    get:
      summary: returns a user by ID.
      parameters:
        - name: userId
          in: path   # the location of paramether
          required: true
          description: parameter description in CommonMark or HTML.
          schema:
            type : integer
            format: int64
            minimum: 1
      responses: 
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                required:
                  - name
                  - surname
                properties:
                  name:
                    type: string
                  surname:
                    type: string
    delete: 
      summary: delete an user by ID
      parameters:
        - name: userId
          in: path
          required: true
          schema:
            type : integer
            format: int64
            minimum: 1
      responses:
        '200':
          description: deleted
                  
